diff -crN ng-1.5alpha3/buffer.c ng-1.5alpha3a/buffer.c
*** ng-1.5alpha3/buffer.c	Sat May 26 00:36:52 2001
--- ng-1.5alpha3a/buffer.c	Fri Dec 27 16:40:59 2002
***************
*** 134,139 ****
--- 134,141 ----
  
  	/* and put it in current window */
  	curbp = bp;
+ 	if (epresf == TRUE)
+ 	  eerase();
  	return showbuffer(bp, curwp, WFFORCE|WFHARD);
  }
  
diff -crN ng-1.5alpha3/echo.c ng-1.5alpha3a/echo.c
*** ng-1.5alpha3/echo.c	Fri Jan  5 23:07:01 2001
--- ng-1.5alpha3a/echo.c	Fri Dec 27 16:31:35 2002
***************
*** 351,356 ****
--- 351,369 ----
  
  static int veread_complete();
  
+ static int veread2();
+ #define MB_NHISTS        4
+ #define MB_HIST_NTYPES   4
+ #define MB_HIST_FUNC       0
+ #define MB_HIST_BUF        1
+ #define MB_HIST_FILE       2
+ #define MB_HIST_MISC       3
+ static int    mb_hist_i = 0;
+ static int    mb_hist_t = 0;
+ static int    mb_hist_n[MB_HIST_NTYPES] = { -1 };
+ static char  *mb_hist_buf[MB_HIST_NTYPES][MB_NHISTS+1];
+     /* Note: mb_hist_buf[*][0] plays a special role. */
+ 
  static int
  veread(fp, buf, nbuf, flag, ap)
    char    *fp;
***************
*** 359,364 ****
--- 372,429 ----
    int    flag;
    va_list *ap;
  {
+   int  i, j, t, v;
+     
+   if (mb_hist_n[0] < 0){
+     mb_hist_t = 0;
+     mb_hist_i = 0;
+     for (i = 0; i < MB_HIST_NTYPES; i++){
+       mb_hist_n[i] = 0;
+       for (j = 0; j <= MB_NHISTS; j++){
+ 	mb_hist_buf[i][j] = NULL;
+       }
+     }
+   }
+ 
+   if ((flag & EFFUNC) != 0)
+     t = MB_HIST_FUNC;
+   else if ((flag & EFBUF) != 0)
+     t = MB_HIST_BUF;
+   else if ((flag & EFFILE) != 0)
+     t = MB_HIST_FILE;
+   else 
+     t = MB_HIST_MISC;
+ 
+   mb_hist_i = 0;
+   mb_hist_t = t;  
+   mb_hist_buf[t][0] = buf;
+   v = veread2(fp, buf, nbuf, flag, ap);
+   mb_hist_buf[t][0] = NULL;
+ 
+   if (v == TRUE){
+     if (mb_hist_buf[t][MB_NHISTS] != NULL){
+       free(mb_hist_buf[t][MB_NHISTS]);
+       mb_hist_n[t]--;
+     }
+     for (i = MB_NHISTS; i > 1; i--)
+       mb_hist_buf[t][i] = mb_hist_buf[t][i-1];
+     mb_hist_buf[t][1] = malloc(strlen(buf)+1);
+     strcpy(mb_hist_buf[t][1], buf);
+     if (mb_hist_n[t] < MB_NHISTS)
+       mb_hist_n[t]++;
+   }
+ 
+   return v;
+ }
+ 
+ static int
+ veread2(fp, buf, nbuf, flag, ap)
+   char    *fp;
+   char    *buf;
+   int    nbuf;
+   int    flag;
+   va_list *ap;
+ {
    int        MetaPrefix, CtluPrefix, nargs, cmp_msg_len, sign, ctluf;
    int        c;
    
***************
*** 495,500 ****
--- 560,596 ----
  	else
  	  while (nargs++ < 0)
  	    complete_scroll_up();
+ 	break;
+       case 'p': case 'P':  /* History, prev */
+ 	if ((mb_hist_n[mb_hist_t] > 0) && (mb_hist_i < mb_hist_n[mb_hist_t])){
+ 	  if (mb_hist_i == 0)
+ 	    mb_get_buffer(buf, nbuf);
+ 	  mb_hist_i++;
+ 	  mb_begl();
+ 	  mb_kill();
+ 	  mb_insertstr(mb_hist_buf[mb_hist_t][mb_hist_i]);
+ 	  mb_begl();
+ 	} else {
+ 	  message("Beginning of history; no preceding item");
+ 	  ttwait();
+ 	}
+ 	mb_redisplay();
+ 	break;
+       case 'n': case 'N':  /* History, next */
+ 	if (mb_hist_n[mb_hist_t] == 0){
+ 	  message("End of history; no default available");
+ 	  ttwait();
+ 	} else if (mb_hist_i > 0){
+ 	  mb_hist_i--;
+ 	  mb_begl();
+ 	  mb_kill();
+ 	  mb_insertstr(mb_hist_buf[mb_hist_t][mb_hist_i]);
+ 	  mb_begl();
+ 	} else {
+ 	  message("End of history; no next item");
+ 	  ttwait();
+ 	}
+ 	mb_redisplay();
  	break;
        default:
  	ttbeep();
diff -crN ng-1.5alpha3/file.c ng-1.5alpha3a/file.c
*** ng-1.5alpha3/file.c	Sat May 26 00:36:52 2001
--- ng-1.5alpha3a/file.c	Fri Dec 27 16:40:24 2002
***************
*** 168,173 ****
--- 168,175 ----
  		  }
  		}
  #endif	/* READONLY */
+ 		if (epresf == TRUE)
+ 		  eerase();
    		return (s);
    	}
  #ifdef	KANJI	/* 90.01.29  by S.Yoshida */
***************
*** 186,191 ****
--- 188,195 ----
  	  }
  	}
  #endif
+ 	if (epresf == TRUE)
+ 	  eerase();
  	return TRUE;
  }
  
